#!/bin/bash
#	Raid.sh	RAIDの作業を行います
#
QUIT=0
#CLI=/opt/MegaRAID/MegaCli/MegaCli64
CLI=/opt/3ware/CLI/tw_cli
CMD=`basename $0`
TMP=/tmp/$CMD
#--------
print_help(){
	case "$1" in
	n)
cat<<@
@
		;;
	p)
cat<<@
OPTION		COMMAND
temp /cX	カードXの物理ディスクの温度を表示
serial /cX	カードXの物理ディスクのシリアル番号を表示
rebuild		物理ディスクのリビルド状態表示
無し		アダプターの情報を表示します
@
		;;
	"")
cat<<@
コマンド
h		help
l /cX/pY	カードXポートYのディスクを点灯
p 		RAIDの情報を取得します
r /cX/pY	カードXポートYのディスクを削除
q		quit

故障の際は：点灯→削除→シャットダウン→
	物理的に交換→再起動

より詳細を見るには, h コマンド　と入力してください
@
		;;
	*)	echo "そいつぁ分かんねぇや"
		;;
	esac
}
#--------
print_temp(){
	$CLI $1 show drivestatus | tail -n +4|while read drive stat unit size size_u type phy encl model
	do
		if [ "$drive" != "" ];then
			serial=`$CLI $1/$drive show serial | cut -f2- -d=`
			temp=`$CLI $1/$drive show all | grep Temperature | cut -f2- -d=`
			speed=`$CLI $1/$drive show all | grep Link\ Speed\ = | cut -f2- -d=`
			printf "%-10s %-10s %-20s %-20s\n" $1/$drive "$temp" "$serial" "$speed"
		fi
	done
}
#--------
print_info(){
	case "$1" in
	s*)	if [ "$2" != "" ];then
			print_temp $2
		else
			$CLI show|tail -n +4|while read card etc
			do
				if [ "/$card" != "/" ];then
					print_temp /$card
				fi
			done
		fi
		;;
	t*)	if [ "$2" != "" ];then
			print_temp $2
		else
			$CLI show|tail -n +4|while read card etc
			do
				if [ "/$card" != "/" ];then
					print_temp /$card
				fi
			done
		fi
		;;
	r*)	$CLI show rebuild
		;;
	"")	echo "=== RAID CARD INFORMATION ==="
		$CLI show
		$CLI show|tail -n +4|while read card etc
		do
			if [ "/$card" != "/" ];then
				echo "=== LOGICAL DISK INFORMATION FOR [/$card] ==="
				$CLI /$card show
				$CLI /$card show unitstatus | tail -n +4| while read unit etc
				do
					if [ "/$unit" != "/" ];then
						echo "    === DISK INFORMATION FOR [/$card/$unit] ==="
						$CLI /$card/$unit show
					fi
				done
			fi
		done
		;;
#Rebuildの状況確認
# 
#/opt/MegaRAID/MegaCli/MegaCli64 -PDRbld -showprog -physdrv[252:0] -a0
# 
#Rebuild Progress on Device at Enclosure 252, Slot 0 Completed 4% in 11 Minutes.
	esac
}
#--------
if [ ! -x $CLI ];then
	echo "Can not executre $CLI."
	exit 4
fi
#
ADAPTOR=0
while [ $QUIT -eq 0 ]
do
	printf "RAID> "
	read ANS ARG1 ARG2
	case "$ANS" in
	h*|"")	print_help $ARG1;;
	l*)	if [ "$ARG1" == "" ];then
			echo "light PHYSICAL_DISK_ID (eg. /c14/p5)"
		fi
		$CLI $ARG1 show
		;;
	p*)	print_info $ARG1 $ARG2;;
	q*)	QUIT=1;;
	r*)	if [ "$ARG1" == "" ];then
			echo "remove PHYSICAL_DISK_ID (eg. /c14/p5)"
		else
			$CLI $ARG1 export
		fi
		;;
	esac
done
